local M = {}

local aTrail

local aBall03
local aBall05
local aBrl02
local aBrl01

local aCooldown

local bTrail

local bBall03
local bBall05
local bBrl02
local bBrl01

local bCooldown

local cTrail

local cBall03
local cBall05
local cBrl02
local cBrl01

local cCooldown

local dTrail

local dBall03
local dBall05
local dBrl02
local dBrl01

local dCooldown

local eTrail

local eBall03
local eBall05
local eBrl02
local eBrl01

local eCooldown

local fTrail

local fBall03
local fBall05
local fBrl02
local fBrl01

local fCooldown

local function onReset()
	aTrail = false
    aCooldown = 0
	bTrail = false
    bCooldown = 0
	cTrail = false
    cCooldown = 0
	dTrail = false
    dCooldown = 0
	eTrail = false
    eCooldown = 0
	fTrail = false
    fCooldown = 0
	
	for k, node in pairs (v.data.nodes) do
		if node.name == "aBall03" then aBall03=k  end
		if node.name == "aBall05" then aBall05=k  end
		if node.name == "aBrl02" then aBrl02=k  end
		if node.name == "aBrl01" then aBrl01=k  end
		
		if node.name == "bBall03" then bBall03=k  end
		if node.name == "bBall05" then bBall05=k  end
		if node.name == "bBrl02" then bBrl02=k  end
		if node.name == "bBrl01" then bBrl01=k  end
		
		if node.name == "cBall03" then cBall03=k  end
		if node.name == "cBall05" then cBall05=k  end
		if node.name == "cBrl02" then cBrl02=k  end
		if node.name == "cBrl01" then cBrl01=k  end
		
		if node.name == "dBall03" then dBall03=k  end
		if node.name == "dBall05" then dBall05=k  end
		if node.name == "dBrl02" then dBrl02=k  end
		if node.name == "dBrl01" then dBrl01=k  end
		
		if node.name == "eBall03" then eBall03=k  end
		if node.name == "eBall05" then eBall05=k  end
		if node.name == "eBrl02" then eBrl02=k  end
		if node.name == "eBrl01" then eBrl01=k  end
		
		if node.name == "fBall03" then fBall03=k  end
		if node.name == "fBall05" then fBall05=k  end
		if node.name == "fBrl02" then fBrl02=k  end
		if node.name == "fBrl01" then fBrl01=k  end
	end
end

local function updateGFX(dt)
	if electrics.values['lCannon1'] == 1 then
    	aTrail = true
    end
	if electrics.values['rCannon1'] == 1 then
    	bTrail = true
    end
	if electrics.values['lCannon2'] == 1 then
    	cTrail = true
    end
	if electrics.values['rCannon2'] == 1 then
    	dTrail = true
    end
	if electrics.values['lCannon3'] == 1 then
    	eTrail = true
    end
	if electrics.values['rCannon3'] == 1 then
    	fTrail = true
    end
	
	if aTrail then
		aCooldown = aCooldown + 1
		if aCooldown < 250 then
			obj:addParticleByNodesRelative(aBall03, aBall05, 0, 34, 0, 1)
			if aCooldown < 30 then
				obj:addParticleByNodesRelative(aBrl02, aBrl01, 5, 49, 1, 10)
				obj:addParticleByNodesRelative(aBrl02, aBrl01, 5, 29, 1, 10)
				obj:addParticleByNodesRelative(aBrl02, aBrl01, 5, 37, 1, 10)
			end
		end
	end
	
	if bTrail then
		bCooldown = bCooldown + 1
		if bCooldown < 250 then
			obj:addParticleByNodesRelative(bBall03, bBall05, 0, 34, 0, 1)
			if bCooldown < 30 then
				obj:addParticleByNodesRelative(bBrl02, bBrl01, 5, 49, 1, 10)
				obj:addParticleByNodesRelative(bBrl02, bBrl01, 5, 29, 1, 10)
				obj:addParticleByNodesRelative(bBrl02, bBrl01, 5, 37, 1, 10)
			end
		end
	end
	
	if cTrail then
		cCooldown = cCooldown + 1
		if cCooldown < 250 then
			obj:addParticleByNodesRelative(cBall03, cBall05, 0, 34, 0, 1)
			if cCooldown < 30 then
				obj:addParticleByNodesRelative(cBrl02, cBrl01, 5, 49, 1, 10)
				obj:addParticleByNodesRelative(cBrl02, cBrl01, 5, 29, 1, 10)
				obj:addParticleByNodesRelative(cBrl02, cBrl01, 5, 37, 1, 10)
			end
		end
	end
	
	if dTrail then
		dCooldown = dCooldown + 1
		if dCooldown < 250 then
			obj:addParticleByNodesRelative(dBall03, dBall05, 0, 34, 0, 1)
			if dCooldown < 30 then
				obj:addParticleByNodesRelative(dBrl02, dBrl01, 5, 49, 1, 10)
				obj:addParticleByNodesRelative(dBrl02, dBrl01, 5, 29, 1, 10)
				obj:addParticleByNodesRelative(dBrl02, dBrl01, 5, 37, 1, 10)
			end
		end
	end
	
	if eTrail then
		eCooldown = eCooldown + 1
		if eCooldown < 250 then
			obj:addParticleByNodesRelative(eBall03, eBall05, 0, 34, 0, 1)
			if eCooldown < 30 then
				obj:addParticleByNodesRelative(eBrl02, eBrl01, 5, 49, 1, 10)
				obj:addParticleByNodesRelative(eBrl02, eBrl01, 5, 29, 1, 10)
				obj:addParticleByNodesRelative(eBrl02, eBrl01, 5, 37, 1, 10)
			end
		end
	end
	
	if fTrail then
		fCooldown = fCooldown + 1
		if fCooldown < 250 then
			obj:addParticleByNodesRelative(fBall03, fBall05, 0, 34, 0, 1)
			if fCooldown < 30 then
				obj:addParticleByNodesRelative(fBrl02, fBrl01, 5, 49, 1, 10)
				obj:addParticleByNodesRelative(fBrl02, fBrl01, 5, 29, 1, 10)
				obj:addParticleByNodesRelative(fBrl02, fBrl01, 5, 37, 1, 10)
			end
		end
	end
end

M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX

return M